﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace DockingSaveLoadLayoutMVVM
{
    public class ViewModel : ViewModelBase
    {
        private string dockingLayout;

        public ViewModel()
        {
            this.SaveLayoutCommand = new DelegateCommand(new Action<object>(this.OnSaveLayoutCommandCommandExecuted));
            this.LoadLayoutSourceCommand = new DelegateCommand(new Action<object>(this.OnLoadLayoutSourceCommandExecuted));
        }

        public ICommand SaveLayoutCommand { get; private set; }
        public ICommand LoadLayoutSourceCommand { get; private set; }

        private void OnSaveLayoutCommandCommandExecuted(object parameter)
        {
            this.dockingLayout = this.SaveLayoutAsString(parameter as RadDocking);
        }

        private void OnLoadLayoutSourceCommandExecuted(object parameter)
        {
            if (!string.IsNullOrEmpty(this.dockingLayout))
            {
                this.LoadLayoutFromString(parameter as RadDocking);
            }
        }

        private string SaveLayoutAsString(RadDocking docking)
        {
            MemoryStream stream = new MemoryStream();
            docking.SaveLayout(stream);
            stream.Seek(0, SeekOrigin.Begin);
            StreamReader reader = new StreamReader(stream);

            return reader.ReadToEnd();
        }

        private void LoadLayoutFromString(RadDocking docking)
        {
            using (Stream stream = new MemoryStream(Encoding.UTF8.GetBytes(dockingLayout)))
            {
                stream.Seek(0, SeekOrigin.Begin);
                docking.LoadLayout(stream);
            }
        }
    }
}
